<?php


class DispletRetsIdxSettings{
	public function init(){
		if (is_admin()) {	
			require_once('settings/settings-config.php');
		}
	}

	public function get_option(){
		return get_option('displet_rets_idx_options');
	}

	public function get_field_option(){
		return get_option('displet_rets_idx_field_options');
	}

	public function set_cookie(){
		check_ajax_referer('displet_set_cookie_nonce');
		if (isset($_POST['action']) && $_POST['action'] == 'displet_set_cookie_request'){
			if (!empty($_POST['name']) && !empty($_POST['value'])) {
        		setcookie($_POST['name'], $_POST['value'], 0, '/');
			}
		}
		die();
	}

	public function get_cookies(){
		check_ajax_referer('displet_get_cookies_nonce');
		if (isset($_POST['action']) && $_POST['action'] == 'displet_get_cookies_request'){
			$cookies = new stdClass();
			$cookies->last_viewed_sort = $_COOKIE['displetretsidx_last_viewed_sort'];
			$cookies->last_viewed_hash = $_COOKIE['displetretsidx_last_viewed_hash'];
			$cookies->last_viewed_orientation = $_COOKIE['displetretsidx_last_viewed_orientation'];
			$cookies->last_viewed_count = $_COOKIE['displetretsidx_last_viewed_count'];
			$cookies->referring_site = $_COOKIE['displetretsidx_referring_site'];
			echo json_encode($cookies);
		}
		die();
	}
}

add_action('init', array('DispletRetsIdxSettings', 'init'));
add_action('wp_ajax_displet_set_cookie_request', array('DispletRetsIdxSettings', 'set_cookie'));
add_action('wp_ajax_nopriv_displet_set_cookie_request', array('DispletRetsIdxSettings', 'set_cookie'));
add_action('wp_ajax_displet_get_cookies_request', array('DispletRetsIdxSettings', 'get_cookies'));
add_action('wp_ajax_nopriv_displet_get_cookies_request', array('DispletRetsIdxSettings', 'get_cookies'));

// Use $displetretsidx_option = DispletRetsIdxSettings::get_option() in any file to retrieve options array
//$displetretsidx_option = DispletRetsIdxSettings::get_option();

?>