<?php

class DispletRetsIdxSidescroller_Widget extends WP_Widget{
	function DispletRetsIdxSidescroller_Widget() {
		// Instantiate the parent object
		parent::__construct(false, 'Displet Listings Scroller', array(
			'description' => 'Show RETS/IDX listings in a horizontal scroller.',
			'classname' => 'displet-sidescroller-widget'
		));
	}

	public function form($instance) {
		$title = (empty($instance['title'])) ? 'Featured Listings' : $instance['title'];
		$title = esc_attr($title);
		$settings = (empty($instance['settings'])) ? array() : $instance['settings'];
?>
		<p>
		<label for="<?php echo $this->get_field_id('title') ?>"><?php _e('Title') ?></label>
		<input type="text"
			name="<?php echo $this->get_field_name('title') ?>"
			id="<?php echo $this->get_field_id('title') ?>" value="<?php echo $title ?>"/>
		</p>
		<p>
		<div class="displet-widget-control">
			<input type="hidden" id="<?php echo $this->get_field_id('settings') ?>"
				name="<?php echo $this->get_field_name('settings') ?>"
				class="displet-widget-control-settings"
				value="<?php echo esc_attr(self::_serialize_for_jquery($settings)) ?>"/>
			<button class="displet-widget-configure">Configure</button>
		
			<span class="displet-widget-control-markup" style="display: none">
		<?php
				// to avoid nesting forms, we must encode the markup for the dialog
				$array = array();
				echo htmlspecialchars(DispletRetsIdxLoad::get_admin_template('widget_form_dialog.phtml',
					$array));
		?>
			</span>
		</div>
		</p>
<?php		
	}

	public function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$array = array();
		parse_str($new_instance['settings'], $array);
		$instance['settings'] = $array;

		$instance['title'] = strip_tags($new_instance['title']);
		return $instance;
	}

	public function widget($args, $instance) {
		$title = apply_filters('widget_title', $instance['title']);

		if (isset($instance['settings']['criteria'])
			&& is_array($instance['settings']['criteria'])) {
			$settings = $instance['settings']['criteria'];
		}
		else {
			$settings = false;
		}

		echo $args['before_widget'];

		if ($title) {
			echo $args['before_title'];
			echo $title;
			echo $args['after_title'];
		}

		if ($settings) {
			$displetretsidx_option = DispletRetsIdxSettings::get_option();
			$model = array(
				'options' => $displetretsidx_option,
				'is_displet_api' => (!empty($displetretsidx_option['displet_app_key'])) ? true : false,
				'region' => stripslashes($displetretsidx_option['oodle_region']),
				'category' => stripslashes($displetretsidx_option['oodle_category']),
				'sort' => stripslashes($displetretsidx_option['listings_sort']),
			);
			$model = array_merge($model, $settings);
			$model['return_fields'] = DispletRetsIdxQuery::get_return_fields($model['options']);
			$model['query_url'] = DispletRetsIdxQuery::get_query_url($model);

			// Get listings server-side to pass to templates for crawlable content
			$listings = DispletRetsIdxQuery::get_listings($model);
			$model = array_merge($model, $listings);

			
			echo DispletRetsIdxLoad::get_template('displet-sidescroller-widget.php', $model);
		}
		else {
			echo '<i>Please configure your DispletReader widget.</i>';
		}
		echo $args['after_widget'];
	}

	// format widget settings so jquery can pick them up
	protected static function _serialize_for_jquery(array $settings) {
		$serialized = http_build_query($settings);
		return $serialized;
	}
}

?>